<?php
header("Content-Type: application/json charset=UTF-8");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Allow-Headers: Access-Control-Allow-Headers,Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With");
include "config.php";
$_POST = json_decode(file_get_contents("php://input"), true);


// admin validation
$admin = $_POST["aid"]; //admin id - for validation
$auth = $_POST["auth"]; //authetication caode(session value) - for validation
$admin_name = $_POST["admin_name"]; //admin name


$mandal_id = $_POST["mid"]; //user mandal id
$trans_type = $_POST["trans_type"]; //transaction type for validate transaction
$regular_installment = $_POST["regular_installment"]; // mandal user regular installment
$loan_id = $_POST["loan_id"]; // mandal user load id
$emi_type = $_POST["emi_type"]; // loan EMI type old or new
$amount = $_POST["amount"]; //amount
$emi = $_POST["emi"]; //loan EMI amount
$emi_interest = $_POST["emi_interest"];// loan EMI interest
$percent = $_POST["percent"];//loan EMI percentage
$late_pay_charge = $_POST["late_pay_charge"];//installment late charge
$annual_charge = $_POST["annual_charge"];//mandal user annual charge
$payment_mode = $_POST["payment_mode"];//payment mode
$today = $_POST["date"];//date
$total = $_POST["total"];//main total
$interest = $_POST["interest"];//loan interest
$month = date("Y-m");//maonth and year for last EMI calculation

//date validation for late pay charge
$valid = date("d", strtotime($today));
$late_pay_charge = "0";
if ($valid > 10) {
    $late_pay_charge = "100";
    $loan_late_pay_charge = "300";
}




//LATE for late installment charge
//NEW for new loan 
//OLD for old loan
//SELF for loan installment interest

$checkadmin = "SELECT `id` FROM `admin` WHERE `id`='$admin' AND `authcode`='$auth'";

$get_checkadmin = mysqli_query($conn, $checkadmin);

if (
    mysqli_num_rows($get_checkadmin) == 1 &&
    (!empty($mandal_id) && !empty($admin_name) && !empty($trans_type))
) {
    if ($emi_type == "NEW" || $emi_type == "OLD") {
          if ($valid > 10) {
            $master_total = $regular_installment - $late_pay_charge;
            $sql = "UPDATE loan SET remaining = remaining - $emi, remaining_month = remaining_month + '1' WHERE id = '$loan_id';
                INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `regular_installment`, `loan_id`, `emi_type`, `emi`, `emi_interest`, `emi_percent`,`annual_charge`, `payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$regular_installment','$loan_id','$emi_type','$emi','$emi_interest','$percent','$annual_charge','$payment_mode','$total','$today');
                INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `late_pay_charge`, `payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','LATE','$loan_late_pay_charge','Self','$loan_late_pay_charge','$today');
                ";
        } else {
          
        $sql = "UPDATE loan SET remaining = remaining - $emi, remaining_month = remaining_month + '1' WHERE id = '$loan_id';
                INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `regular_installment`, `loan_id`, `emi_type`, `emi`, `emi_interest`, `emi_percent`,`annual_charge`, `payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$regular_installment','$loan_id','$emi_type','$emi','$emi_interest','$percent','$annual_charge','$payment_mode','$total','$today');
                ";
        }
        
    } elseif ($trans_type == "WITHDRAW") {
        $sql = "INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`,`withdraw`, `payment_mode`,`date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$amount','$payment_mode','$today')";
                
    } elseif ($trans_type == "INTEREST" && $emi_type == "ADD") {
        $sql = "UPDATE loan SET interest=interest+$interest WHERE id = '$loan_id';
                INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `regular_installment`, `loan_id`, `emi_type`,`emi_interest`,`payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$regular_installment','$loan_id','$emi_type','$interest','$payment_mode','$total','$today');";
                
    } elseif ($trans_type == "INTEREST" && $emi_type == "REMOVE") {
        $sql = "UPDATE loan SET interest=interest-$interest WHERE id = '$loan_id';
                INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `regular_installment`, `loan_id`, `emi_type`, `emi_interest`,`payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$regular_installment','$loan_id','$emi_type','$interest','$payment_mode','$total','$today');";
                
    } elseif ($trans_type == "YB") {
        $sql = "INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`,`regular_installment`,`total`, `payment_mode`,`date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$regular_installment','$regular_installment','$payment_mode','$today')";
                
    } elseif ($trans_type == "REGULAR") {
        if ($valid > 10) {
            $master_total = $regular_installment - $late_pay_charge;
            $sql = "INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `regular_installment`, `payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$master_total','$payment_mode','$master_total','$today');
                INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `late_pay_charge`, `payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','LATE','$late_pay_charge','Self','$late_pay_charge','$today');
                UPDATE mandal_user SET last_trans = '$month' WHERE id = '$mandal_id';";
        } else {
            $sql = "INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `regular_installment`, `payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$regular_installment','$payment_mode','$total','$today');
                UPDATE mandal_user SET last_trans = '$month' WHERE id = '$mandal_id';";
        }
    } else {
        $sql = "INSERT INTO `transaction`(`mid`, `aid`, `a_name`, `trans_type`, `regular_installment`, `loan_id`, `emi_type`, `emi`, `emi_interest`, `emi_percent`, `late_pay_charge`, `annual_charge`, `payment_mode`, `total`, `date`) 
                VALUES ('$mandal_id','$admin','$admin_name','$trans_type','$regular_installment','$loan_id','$emi_type','$emi','$emi_interest','$percent','$late_pay_charge','$annual_charge','$payment_mode','$total','$today');
                UPDATE mandal_user SET last_trans = '$month' WHERE id = '$mandal_id';";
    }

    if ($conn->multi_query($sql) === true) {
        echo json_encode(["message" => "radha"]);
    } else {
        echo json_encode(["message" => "invalid"]);
    }
} else {
    echo json_encode(["message" => "invalid"]);
}
?>
